"
 COPYRIGHT (c) 1992 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

EnterBox subclass:#TextBox
	 instanceVariableNames:'textView'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Views-DialogBoxes'
!

TextBox comment:'
COPYRIGHT (c) 1992 by Claus Gittinger
	      All Rights Reserved

$Header: /cvs/stx/stx/libwidg2/TextBox.st,v 1.10 1995-06-06 04:17:57 claus Exp $
'!

!TextBox class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1992 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
"
$Header: /cvs/stx/stx/libwidg2/TextBox.st,v 1.10 1995-06-06 04:17:57 claus Exp $
"
!

documentation
"
    this class implements a pop-up box to enter some text with 2 buttons,
    one to cancel, another to start some action.
    It is basically an enterBox, but allows entering of more than one line
    of text.
"
!

examples
"
    Example:

	|t|

	t := TextBox new.
	t title:'enter some text'.
	t action:[:text | Transcript showCr:('the entered text was:\' , text) withCRs].
	t showAtPointer
"
! !

!TextBox class methodsFor:'defaults'!

defaultExtent
    ^ (Display pixelPerMillimeter * (120 @ 90)) rounded
! !

!TextBox methodsFor:'initialization'!

initialize
    |space2 space3 innerWidth|

    super initialize.

    space2 := 2 * ViewSpacing.
    space3 := 3 * ViewSpacing.

    "kludge: preset extent to something useful since other subviews
     depend on it (extent blocks are not evaluated until view is realized)
     - avoid visible resizing when realized the first time"

    innerWidth := width - space2.

    textView := HVScrollableView for:EditTextView miniScrollerH:true in:self.
    textView origin:(ViewSpacing @ (space2 + labelField height))
	     extent:(innerWidth @ (height - ViewSpacing -
				   labelField height - ViewSpacing -
				   buttonPanel height - space3) ).
    textView origin:[ViewSpacing @ (space2 + labelField height)]
	     extent:[(width - space2) @ (height - ViewSpacing -
				   labelField height - ViewSpacing -
				   buttonPanel height - space3) ].

    self delegate:(KeyboardForwarder toView:textView scrolledView)

    "TextBox new showAtPointer"
! !

!TextBox methodsFor:'queries'!

preferredExtent
    "return the extent needed to make everything visible"

    |wWanted hWanted wPanel|

    wWanted := labelField width + ViewSpacing + ViewSpacing.
    (wWanted > width) ifFalse:[
	wWanted := width
    ].
    wPanel := ViewSpacing * 3.
    buttonPanel subViews do:[:aView |
	wPanel := wPanel + aView width + ViewSpacing
    ].
    wPanel > wWanted ifTrue:[
	wWanted := wPanel
    ].
    hWanted := ViewSpacing + labelField height +
	       ViewSpacing + textView height +
	       (ViewSpacing * 6) + buttonPanel preferredExtent y +
	       ViewSpacing.
    ^ (wWanted @ hWanted)
! !

!TextBox methodsFor:'accessing'!

initialText:aString
    "define the initial text in the enterfield"

    textView contents:aString
!

textView
    ^ textView
!

contents
    "return my contents"

    ^ textView contents
! !
